## deepin-keyring-whitebox 1.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(deepin-keyring-whitebox VERSION 1.0 LANGUAGES C CXX)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr CACHE PATH "/usr" FORCE)
endif()

enable_testing()

add_subdirectory("src")
add_subdirectory("misc")

=== misc/CMakeLists.txt ===

configure_file(pkgconfig/libdeepin-keyring-whitebox.pc.in libdeepin-keyring-whitebox.pc @ONLY)
set(PKGCONFIG
    ${CMAKE_BINARY_DIR}/misc/libdeepin-keyring-whitebox.pc
)
install(FILES ${PKGCONFIG} DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE}/pkgconfig)

set(AUTOSTART
    autostart/deepin-keyring-whitebox-notify.desktop
)
install(FILES ${AUTOSTART} DESTINATION /etc/xdg/autostart/)

set(PAM_D
    pam.d/deepin-keyring-whitebox-password
)
install(FILES ${PAM_D} DESTINATION /etc/pam.d/)

=== src/CMakeLists.txt ===
set(DK_COMPILE_FLAGS "-W -Wall -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
set(SRC_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_compile_definitions(DK_DEBUG_MODE)
endif()

add_compile_definitions(_GNU_SOURCE)

# core：module的依赖，避免重复代码和重复编译
set(CORE_LIB_NAME "core")
add_subdirectory("core")

# module
add_subdirectory("deepin-keyring-whitebox")
add_subdirectory("pam-deepin-keyring")
add_subdirectory("libdeepin-keyring-whitebox")

# dpa-plugin
add_subdirectory("dpa-deepin-keyring-whitebox-plugin")

add_subdirectory("tests")

=== src/core/CMakeLists.txt ===
set(CMAKE_C_FLAGS ${DK_COMPILE_FLAGS})

file(GLOB_RECURSE CORE_LIB_SRCS
    "*.h"
    "*.c"
)

add_library(${CORE_LIB_NAME} STATIC
    ${CORE_LIB_SRCS}
)

=== src/deepin-keyring-whitebox/CMakeLists.txt ===

set(M_NAME "deepin-keyring-whitebox")

set(CMAKE_C_FLAGS ${DK_COMPILE_FLAGS})

file(GLOB_RECURSE SRCS
    "*.h"
    "*.c"
)

add_executable(${M_NAME}
    ${SRCS}
)
add_dependencies(${M_NAME} ${CORE_LIB_NAME})

target_include_directories(${M_NAME} PUBLIC
    ${SRC_BASE_DIR}/core/
)

target_link_libraries(${M_NAME} PRIVATE
    ${PROJECT_BINARY_DIR}/src/core/libcore.a
    -lpam
    -ldl
)

install(TARGETS ${M_NAME} DESTINATION bin)

=== src/dpa-deepin-keyring-whitebox-plugin/CMakeLists.txt ===

set(POLKIT_AGNET_PLUGIN_NAME "dpa-deepin-keyring-whitebox-plugin")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS ${DK_COMPILE_FLAGS})

find_package(Qt6 COMPONENTS Core Widgets REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

add_compile_definitions(DPAEXTGNOMEKEYRING_LIBRARY)

file(GLOB_RECURSE POLKIT_AGNET_PLUGIN_SRCS
    "*.h"
    "*.cpp"
)

add_library(${POLKIT_AGNET_PLUGIN_NAME} MODULE
    ${POLKIT_AGNET_PLUGIN_SRCS}
)
add_dependencies(${POLKIT_AGNET_PLUGIN_NAME} ${CORE_LIB_NAME})
set_target_properties(${POLKIT_AGNET_PLUGIN_NAME} PROPERTIES OUTPUT_NAME "dpa-deepin-keyring-whitebox")
target_include_directories(${POLKIT_AGNET_PLUGIN_NAME} PUBLIC
    ${SRC_BASE_DIR}/core/
)
target_link_libraries(${POLKIT_AGNET_PLUGIN_NAME} PRIVATE
    ${PROJECT_BINARY_DIR}/src/core/libcore.a
    Qt6::Core
    Qt6::Widgets
    Qt6::DBus
)

install(TARGETS ${POLKIT_AGNET_PLUGIN_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/polkit-1-dde/plugins)

=== src/pam-deepin-keyring/CMakeLists.txt ===

set(PAM_LIB_NAME "pam_deepin_keyring")

set(CMAKE_C_FLAGS ${DK_COMPILE_FLAGS})

file(GLOB_RECURSE LIB_SRCS
    "*.h"
    "*.c"
)

add_library(${PAM_LIB_NAME} MODULE
    ${LIB_SRCS}
)
add_dependencies(${PAM_LIB_NAME} ${CORE_LIB_NAME})
set_target_properties(${PAM_LIB_NAME} PROPERTIES PREFIX "")
target_include_directories(${PAM_LIB_NAME} PUBLIC
    ${SRC_BASE_DIR}/core/
)
target_link_libraries(${PAM_LIB_NAME} PRIVATE
    ${PROJECT_BINARY_DIR}/src/core/libcore.a
    -lpam
)

install(TARGETS ${PAM_LIB_NAME} DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE}/security)

=== src/tests/CMakeLists.txt ===

set(TEST_NAME "deepin-keyring-whitebox-tests")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS ${DK_COMPILE_FLAGS})

# 用于测试覆盖率的编译条件
# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")
find_package(GTest REQUIRED)

file(GLOB_RECURSE TEST_SRCS
    "*.h"
    "*.cpp"
)

add_executable(${TEST_NAME}
    ${TEST_SRCS}
)
add_dependencies(${TEST_NAME} ${CORE_LIB_NAME})
target_include_directories(${TEST_NAME} PUBLIC
    ${SRC_BASE_DIR}/core/
)
target_link_libraries(${TEST_NAME} PRIVATE
    ${PROJECT_BINARY_DIR}/src/core/libcore.a
    ${GTEST_LIBRARIES}
    -lpthread
    -ldl
)

add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME} "--gtest_output=xml:${PROJECT_BINARY_DIR}/ut-test-report.xml")

=== debian/changelog ===
deepin-keyring-whitebox (1.0.4) unstable; urgency=medium

  * update changelog.

 -- lichenggang <lichenggang@deepin.org>  Fri, 07 Mar 2025 15:34:12 +0800

deepin-keyring-whitebox (1.0.2) unstable; urgency=medium

  * fix: 修复部分场景无法使用白盒问题

 -- Chengqqi E <echengqi@uniontech.com>  Thu, 20 Feb 2025 18:20:35 +0800

deepin-keyring-whitebox (1.0.1) unstable; urgency=medium

  [ Deepin Packages Builder ]
  * feat: 增加对域管场景和清空密钥环场景的支持(Task: 262399)(Influence: keyring白盒功能)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 25 May 2023 14:20:35 +0800

deepin-keyring-whitebox (1.0.0) unstable; urgency=medium

  * init

 -- Tan Feng <tanfeng@uniontech.com>  Thu, 27 Apr 2023 17:33:52 +0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake

## deepin-keyring-whitebox 1.0.5

=== debian/changelog ===
deepin-keyring-whitebox (1.0.5) unstable; urgency=medium

  * feat: 支持根据快速登录的配置来决定是否切换白盒.

 -- zhaoyingzhen <zhaoyingzhen@uniontech.com>  Thu, 05 Jun 2025 14:35:12 +0800

## deepin-keyring-whitebox 1.0.6

=== misc/CMakeLists.txt ===
--- 
+++ 
@@ -14,3 +14,8 @@
     pam.d/deepin-keyring-whitebox-password
 )
 install(FILES ${PAM_D} DESTINATION /etc/pam.d/)
+
+set(DCONFIG
+    "dsg-configs/org.deepin.dde.keyring.whitebox.json"
+)
+install(FILES ${DCONFIG} DESTINATION share/dsg/configs/org.deepin.dde.keyring/)

=== src/libdeepin-keyring-whitebox/CMakeLists.txt ===

set(LIB_NAME "libdeepin-keyring-whitebox")

set(CMAKE_C_FLAGS ${DK_COMPILE_FLAGS})

file(GLOB_RECURSE LIB_SRCS
    "*.h"
    "*.c"
)

add_library(${LIB_NAME} SHARED
    ${LIB_SRCS}
)
add_dependencies(${LIB_NAME} ${CORE_LIB_NAME})
set_target_properties(${LIB_NAME} PROPERTIES OUTPUT_NAME "deepin-keyring-whitebox" VERSION ${PROJECT_VERSION})
target_include_directories(${LIB_NAME} PUBLIC
    ${SRC_BASE_DIR}/core/
)
target_link_libraries(${LIB_NAME} PRIVATE
    ${PROJECT_BINARY_DIR}/src/core/libcore.a
)

install(TARGETS ${LIB_NAME} DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE})
install(FILES deepin_keyring_whitebox.h DESTINATION ${CMAKE_INSTALL_PREFIX}/include)

=== debian/changelog ===
deepin-keyring-whitebox (1.0.6) unstable; urgency=medium

  * Fix: 启用微信扫码登录触发白盒
  * Feat: 优化密钥环提示，增加配置值开启白盒

 -- fuleyi <fuleyi@uniontech.com>  Fri, 29 Aug 2025 09:10:44 +0800

=== debian/control ===
Source: deepin-keyring-whitebox
Section: devel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 cmake,
 debhelper-compat (= 11),
 pkg-config,
 libpam-dev,
 dde-polkit-agent-dev,
 qt6-base-dev,
 libgtest-dev,
Standards-Version: 4.1.3
Homepage: https://www.deepin.org

Package: deepin-keyring-whitebox
Architecture: any
Depends:
 dde-crypto (>= 1.0.2),
 ${misc:Depends},
 ${shlibs:Depends},
Description: deepin whitebox extension for GNOME keyring.
 This is an extension project provided by deepin, which implements a solution for a password free scenario of gnome keyring.

Package: libdeepin-keyring-whitebox-dev
Architecture: any
Depends:
 deepin-keyring-whitebox,
 ${misc:Depends},
 ${shlibs:Depends},
Description: deepin whitebox extension development Library.
 The project encapsulates the details of the white box solution to avoid external involvement.
